Codeforces Round #262 (Div. 2) 1004

2022-10-26,

Codeforces Round #262 (Div. 2) 1004

D. Little Victor and Set

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

Little Victor adores the sets theory. Let us remind you that a set is a group of numbers where all numbers are pairwise distinct. Today Victor wants to find a set of integers S that has the following properties:

for all x

the following inequality holds l ≤ x ≤ r;

1 ≤ |S| ≤ k;

lets denote the i-th element of the set S as si; value

must be as small as possible.

Help Victor find the described set.

Input

The first line contains three space-separated integers l, r, k (1 ≤ l ≤ r ≤ 1012; 1 ≤ k ≤ min(106, r - l + 1)).

Output

Print the minimum possible value of f(S). Then print the cardinality of set |S|. Then print the elements of the set in any order.

If there are multiple optimal sets, you can print any of them.

Sample test(s)

input

8 15 3

output



10 11

input

8 30 7

output



14 9 28 11 16

Note

Operation

represents the operation of bitwise exclusive OR. In other words, it is the XOR operation.

【分析】很显然的结论,K^(K+1)=1,其中K是偶数。当K>3时,我们可以选连续的4个自然数使异或和为0。(当然注意要特判R-L+1的大小)。当K=1时,就是L。当K=2时,显然只能构造异或为1的情况。

所有的推论都指向一个问题:当K=3的一般情况怎么做?

【题解】对于那个情况,我一直觉得能贪心构造,但是怎么也想不出简单易行且效率高的算法。

其实很简单。我们设L<=X<Y<Z<=R,然后来贪心构造他们。

在二进制中,异或和为0的情况是1,1,0或0,0,0。显然Z的第一位是1,然后X和Y是0。

因为是贪心,我们要尽量使Y靠近Z(因为如果Z符合范围,Y显然越大越好)。

那么第二位我们就让Y靠近Z。我们把Z那位设成0,X和Y都设成1,即如下形式:

110000000

101111111

011111111

wa了很多次,

1.没有用long long

2.只有l^(l+1) l为偶数时,才能异或值为1

3.当k>=4但是不存在4个数异或为0的时候,没考虑3个也可能为0

4.1<<35超过int 得写成(long long)1<<35

5.当2个异或不是1时,应该判断他的值和l的大小

 #include <cstring>

 #include <iostream>

 #include <algorithm>

 #include <cstdio>

 #include <cmath>

 #include <map>

 #include <cstdlib>

 #define M(a,b) memset(a,b,sizeof(a))

 #define INF 0x3f3f3f3f

 using namespace std;

 long long l,r,k;

 int main()

 {

     scanf("%I64d%I64d%I64d",&l,&r,&k);

     if(k==) printf("%I64d\n1\n%I64d\n",l,l);

     else if(k==)

     {

         if(l%==)

         printf("1\n2\n%I64d %I64d\n",l,l+);

         else if(l+<=r)

         printf("1\n2\n%I64d %I64d\n",l+,l+);

         else if(((l)^(l+))<l) {

                 //cout<<(((l)^(l+1))-l)<<endl;

                 printf("%I64d\n2\n%I64d %I64d\n",(l)^(l+),l,l+);

         }

         else printf("%I64d\n1\n%I64d\n",l,l);

     }

     else if(k>=)

     {

         if(l%==)

           printf("0\n4\n%I64d %I64d %I64d %I64d\n",l,l+,l+,l+);

         else if(l+<r)

           printf("0\n4\n%I64d %I64d %I64d %I64d\n",l+,l+,l+,l+);

         else if(((l)^(l+)^(l+)^(l+))==)printf("0\n4\n%I64d %I64d %I64d %I64d\n",l,l+,l+,l+);

          else

     {

         int count1 = ;

         long long tem1 = r;

         while(tem1>)

         {

             tem1 = tem1>>;

             count1++;

         }

         //cout<<count1<<endl;

         int cnt = ;

         long long ans1 = ;

         long long ans2 = ;

         for(int i = count1-;i>=;i--)

         {

             if(((r>>i)&)==)

             {

                 if(cnt == )

                 {

                   ans1 = ans1|((long long)<<i);

                   cnt++;

                 }

                 else if(cnt >= )

                 {

                     ans2 = ans2|((long long)<<i);

                     cnt++;

                 }

             }

             else

             {

                 if(cnt>)

                 {

                     ans1 = ans1|((long long)<<i);

                     ans2 = ans2|((long long)<<i);

                 }

             }

         }

         if(ans2<l)

         {

             if(l%==)

                 printf("1\n2\n%I64d %I64d\n",l,l+);

             else printf("1\n2\n%I64d %I64d\n",l+,l+);

         }

         else printf("0\n3\n%I64d %I64d %I64d\n",ans1,ans2,r);

     }

     }

     else

     {

         int count1 = ;

         long long tem1 = r;

         while(tem1>)

         {

             tem1 = tem1>>;

             count1++;

         }

         //cout<<count1<<endl;

         int cnt = ;

         long long ans1 = ;

         long long ans2 = ;

         for(int i = count1-;i>=;i--)

         {

             if(((r>>i)&)==)

             {

                 if(cnt == )

                 {

                   ans1 = ans1|((long long)<<i);

                   cnt++;

                 }

                 else if(cnt >= )

                 {

                     ans2 = ans2|((long long)<<i);

                     cnt++;

                 }

             }

             else

             {

                 if(cnt>)

                 {

                     ans1 = ans1|((long long)<<i);

                     ans2 = ans2|((long long)<<i);

                 }

             }

             //cout<<ans2<<' '<<ans1<<endl;

         }

         //cout<<ans2<<' '<<ans1<<endl;

         if(ans2<l)

         {

             if(l%==)

                 printf("1\n2\n%I64d %I64d\n",l,l+);

             else printf("1\n2\n%I64d %I64d\n",l+,l+);

         }

         else printf("0\n3\n%I64d %I64d %I64d\n",ans1,ans2,r);

     }

     return ;

 }

Codeforces Round #262 (Div. 2) 1004的相关教程结束。

《Codeforces Round #262 (Div. 2) 1004.doc》

下载本文的Word格式文档,以方便收藏与打印。